## debram 0.4.1

=== Makefile ===

# Setting the DEBRAM_LOCAL environment variable causes this makefile
# correctly to build `debram' locally in the present directory, such
# that the `debram' executable seeks its library data file locally.
# To build `debram' locally, enter
#
#   $ DEBRAM_LOCAL=1 make
#
# Otherwise, this makefile builds `debram' for Debian packaging and
# distribution, such that the `debram' executable seeks its library data
# file in `/usr/lib/debram/':
#
#   $ make
#
# To prepare for an all-new build, enter one of
#
#   $ make clean
#   $ DEBRAM_LOCAL=1 make clean
#
# (The only difference between the two is that the latter cleans
# a few extra scratchpad files up, if they exist, as specified
# by $(clean_local) below.)
#
# To view the manpage locally, enter
#
#   $ man ./debram.1
#

prog     := debram

ifdef DEBRAM_LOCAL
  ccdef       := -DDEBRAM_LOCAL
  warn        := -Wall
  clean_local := a.out out err
else
  optim       := -O2 -fomit-frame-pointer
endif

CFLAGS   += $(warn) $(ccdef) $(optim)
LDFLAGS  += $(warn)

LDLIBS   += -lz

def_h     =                      def.h
gen_h     = $(def_h)             gen.h
alloc_h   =                      alloc.h
strx_h    = $(def_h)             strx.h
conv_h    = $(def_h)             conv.h
argp_h    = $(def_h)             argp.h
sel_h     = $(def_h)             sel.h
color_h   = $(def_h) $(argp_h)   color.h
ldf_h     = $(def_h)             ldf.h
datum_h   = $(def_h)             datum.h
xref_h    = $(def_h)             xref.h
plan_h    = $(def_h)             plan.h
prdeb_h   = $(def_h) $(datum_h)  prdeb.h
prram_h   = $(def_h) $(xref_h)   prram.h
find_h    = $(def_h)             find.h
main_h    = $(def_h)             main.h

obj      := strx.o   \
            conv.o   \
            argp.o   \
            sel.o    \
            color.o  \
            ldf.o    \
            datum.o  \
            xref.o   \
            plan.o   \
            prdeb.o  \
            prram.o  \
            find.o   \
            main.o

$(prog)   : $(obj)
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(obj)    : $(gen_h)
strx.o    : $(strx_h)
conv.o    : $(conv_h)
argp.o    : $(argp_h)   $(alloc_h)
sel.o     : $(sel_h)    $(alloc_h)
color.o   : $(color_h)  $(argp_h)
ldf.o     : $(ldf_h)    $(argp_h)
datum.o   : $(datum_h)  $(conv_h)   \
                        $(argp_h)   \
                        $(ldf_h)
xref.o    : $(xref_h)   $(strx_h)   \
                        $(argp_h)   \
                        $(datum_h)  \
                        $(alloc_h)
plan.o    : $(plan_h)   $(argp_h)   \
                        $(color_h)  \
                        $(xref_h)
prdeb.o   : $(prdeb_h)  $(strx_h)   \
                        $(argp_h)   \
                        $(sel_h)    \
                        $(color_h)  \
                        $(datum_h)
prram.o   : $(prram_h)  $(conv_h)   \
                        $(argp_h)   \
                        $(color_h)  \
                        $(datum_h)  \
                        $(prdeb_h)
find.o    : $(find_h)   $(strx_h)   \
                        $(argp_h)   \
                        $(datum_h)  \
                        $(xref_h)   \
                        $(prdeb_h)
main.o    : $(main_h)   $(argp_h)   \
                        $(sel_h)    \
                        $(xref_h)   \
                        $(plan_h)   \
                        $(prram_h)  \
                        $(find_h)

.PHONY    : clean
clean     :
	rm -f $(prog) $(obj) $(clean_local)

=== debian/changelog ===
debram (0.4.1) unstable; urgency=low

  * Corrected `debian/control' to include a build-dependency
    on `zlib1g-dev'.  Closes #231100.

 -- Thaddeus H. Black <t@b-tk.org>  Fri,  6 Feb 2004 00:00:00 +0000

debram (0.4.0) unstable; urgency=low

  * Incremented the version number to 0.4.0 for sponsor Giacomo
    Catenazzi's upload to Debian's unstable archive.  Updated the
    various package dates, histories and version notations accordingly
    but made no other changes to the package.

 -- Thaddeus H. Black <t@b-tk.org>  Fri, 23 Jan 2004 00:00:00 +0000

debram (0.3.1e) experimental; urgency=low

  * Corrected and neatened `helper/new-debram-body' in several small
    ways.  Improved its error messages generally.  Added and documented
    the useful new "unknown maintainer" error message.  Added the -w
    option.
  * Updated `maint.txt'.
  * Updated the manpage's Bugs section.
  * Added some nomenclature to the manpage's Ramification section.

 -- Thaddeus H. Black <t@b-tk.org>  Tue, 20 Jan 2004 00:00:00 +0000

debram (0.3.1d) experimental; urgency=low

  * Removed the `author/' directory and added the new `helper/'
    directory.  The old directory had contained undocumented scripts and
    other files which probably were useless to anyone but the author.
    The new directory contains documented scripts and files potentially
    useful to any debram developer.
  * In `debian/control', added explicit Section and Priority data to
    each binary paragraph; removed the Enhances datum.
  * Updated `maint.txt' to include all the names of sarge's current
    maintainers.  (Debian sarge is in testing at the time of this
    writing.)

 -- Thaddeus H. Black <t@b-tk.org>  Fri, 16 Jan 2004 00:00:00 +0000

debram (0.3.1c) experimental; urgency=low

  * Removed `author/author.tar'.
  * Corrected FTP link in `debian/copyright'.
  * Per Giacomo Catenazzi's suggestion, added error checking to all the
    program's calls to malloc(3) and calloc(3).  (See `alloc.h'.)
  * Conformed to Standards Version 3.5.10.
  * Configured the source to build with debhelper 4.1.  (This means that
    the source now builds for sarge only, not woody.  Debian 3.0 woody
    users should install the old debram 0.3.1.)
  * Retagged `cmdsel.txt' for doc-base.

 -- Thaddeus H. Black <t@b-tk.org>  Mon,  5 Jan 2004 00:00:00 +0000

debram (0.3.1) unstable; urgency=low

  * Tracked Debian's 3.0r2 issue.
  * Slightly altered the sorting of package names within a ram, letting
    packages from the same source appear sequentially.
  * Corrected five or six misramifications.
  * Because the debram's own control file refers to them, added
    packages `debram-data' and `debtags' (`debram' had already been
    added in 0.2.0).
  * Corrected color output to xterm(1).
  * Noted here for historical interest that a debram 0.1.0 did exist,
    but that it consisted solely of the unpackaged file `cmdsel.txt'.
    Its issue date was 29 May 2002.  While it was not then a Debian
    package and was not called `debram', it is the direct antecedent of
    today's debram package.

 -- Thaddeus H. Black <t@b-tk.org>  Fri, 26 Dec 2003 00:00:00 +0000

debram (0.3.0) unstable; urgency=low

  * Recast the source as a native Debian package.
  * Split the data files away into a separate, architecture-independent
    binary package `debram-data'.
  * Added new -1 and -s options to debram(1).
  * Extended debram(1)'s -T option to enhance -d and -m.
  * Extended debram(1)'s -d and -m options to accept ram specification.
  * Trimmed and updated debram(1)'s manpage.

 -- Thaddeus H. Black <t@b-tk.org>  Mon, 15 Dec 2003 13:14:07 +0000

debram (0.2.0-1) unstable; urgency=low

  * Initial Release.

 -- Thaddeus H. Black <t@b-tk.org>  Mon, 24 Nov 2003 02:36:26 +0000

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: debram
Section: admin
Priority: extra
Maintainer: Thaddeus H. Black <t@b-tk.org>
Build-Depends: debhelper (>= 4.1.0), zlib1g-dev (>= 1:1.1.4-1.0woody0)
Standards-Version: 3.5.10

Package: debram
Section: admin
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, debram-data (= ${Source-Version})
Suggests: debtags
Description: Ramified catalog of available .debs
 Debian GNU/Linux provides thousands upon daunting thousands of software
 packages.  Sorting them into broad classes then dividing and redividing
 them into finer, more specific branches, the Debram ramifies Debian's
 packages in much the same manner as a university library ramifies its
 books.  If you know what you want your computer to do but do not yet
 know the package to do it, you can find the package here.
 .
 (While highly useful, this preliminary version covers only packages
 distributed with Debian 3.0 woody.  Debian sarge's thousands of new
 packages are not yet included.)

Package: debram-data
Section: admin
Priority: extra
Architecture: all
Recommends: debram (= ${Source-Version})
Description: Ramified catalog of available .debs
 Debian GNU/Linux provides thousands upon daunting thousands of software
 packages.  Sorting them into broad classes then dividing and redividing
 them into finer, more specific branches, the Debram ramifies Debian's
 packages in much the same manner as a university library ramifies its
 books.  If you know what you want your computer to do but do not yet
 know the package to do it, you can find the package here.
 .
 (While highly useful, this preliminary version covers only packages
 distributed with Debian 3.0 woody.  Debian sarge's thousands of new
 packages are not yet included.)
 .
 This package provides the Debram's architecture-independent data files.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules using debhelper.
# GNU copyright 1997 by Joey Hess.
# Modified by Thaddeus H. Black for debram.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build-arch: configure-stamp  build-arch-stamp
build-arch-stamp:
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep:  configure-stamp build-indep-stamp
build-indep-stamp:
	dh_testdir
	touch build-indep-stamp

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_install debram usr/bin

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installchangelogs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_link -a usr/share/doc/debram-data \
	  usr/share/doc/debram
	dh_installdocs -a
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_link -a usr/share/doc/debram-data/debram.txt.gz \
	  usr/lib/debram/debram.txt.gz
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## debram 0.6.1

=== Makefile ===
--- 
+++ 
@@ -28,12 +28,13 @@
 
 prog     := debram
 
+DEBRAM_OPTIM_LVL ?= -O2
 ifdef DEBRAM_LOCAL
   ccdef       := -DDEBRAM_LOCAL
   warn        := -Wall
   clean_local := a.out out err
 else
-  optim       := -O2 -fomit-frame-pointer
+  optim       := $(DEBRAM_OPTIM_LVL) -g -fomit-frame-pointer
 endif
 
 CFLAGS   += $(warn) $(ccdef) $(optim)

=== debian/changelog ===
debram (0.6.1) unstable; urgency=low

  * Updated the ramification data to reflect sarge as of this date.
  * Updated maint.txt.

 -- Thaddeus H. Black <t@b-tk.org>  Fri,  3 Dec 2004 21:00:00 +0000

debram (0.6.0) unstable; urgency=low

  * Included the new sarge debram.txt, with sarge packages ramified per
    the new sarge ramification plan.
  * Because debram.txt now presents current data, removed
    the "Priority: extra" from debian/control, reverting
    to "Priority: optional".
  * Reformed the binary packages' Descriptions.  In particular, gave
    debram-data its own distinct Description and removed the
    now-obsolete woody disclaimer.
  * Updated the manpage to cover the new sarge data issue.
  * Sorted team-maintained packages to the head of each ram,
    except "Tm QA" packages, which are sorted to the foot.
  * Updated debian/README.
  * Updated and extended the development helper scripts.
  * At last understanding Colin Watson's suggestion of three months ago,
    fixed the various development helper scripts to use FindBin to
    locate Perl modules and other files relative to the helper/
    directory.
  * Updated maint.txt.

 -- Thaddeus H. Black <t@b-tk.org>  Mon,  8 Nov 2004 21:00:00 +0000

debram (0.5.2) unstable; urgency=low

  * Reprioritized the list of sites from which users can download future
    debram data.
  * Applied Gustavo Franco's manpage patch, correcting the reference in
    the Files section from /usr/lib/debram/ to /usr/share/debram/
    (closes: #276577).
  * Updated and shortened the manpage's Bugs section.
  * Added appropriate acknowledgements to the manpage's Author section.
  * Revised the manpage in several other minor respects.
  * Relaxed the source's Build-Dependency on debhelper, making the same
    debram source equally buildable on woody, sarge and sid platforms.
  * Added the new helper scripts check-maint-addr and check-ram-titles;
    added the new -tmT options to the helper script new-debram-body;
    fixed the helper script buff-expand, stopping it from touching the
    revision timestamps of files it does not alter; edited other
    helpers in minor ways.
  * Updated maint.txt.

 -- Thaddeus H. Black <t@b-tk.org>  Tue, 26 Oct 2004 00:00:00 +0000

debram (0.5.1) unstable; urgency=high

  * Credited Martin Pitt here for discovering the need for the
    following five changes.
  * In the debram-data binary, moved debram.txt from
    /usr/share/doc/debram-data/ to /usr/share/debram-data/,
    to comply with Policy sect 12.3 (closes: #272422).
  * In the debram binary, symlinked the platform-
    independent `debram.txt.gz' from /usr/share/debram/ rather
    than /usr/lib/debram/, to comply with FHS sect 4.7.
  * Removed unneeded empty maintainer scripts (debhelper creates
    suitable default maintainer scripts automatically).
  * To comply with Policy sect 10.1, altered `Makefile' and debian/rules
    - always to compile with debugging symbols (except during a
      local, non-packaging build), stripping unwanted symbols after
      compilation; and
    - to respect "noopt" in DEB_BUILD_OPTIONS.
  * Removed superfluous "configure" target from debian/rules.
  * Because data files have moved (see above), controlled debram-data
    to Conflict against old debram (<< 0.5.1).  (Future debram-data are
    to be compatible with any debram (>= 0.5.1).  If an incomptatible
    debram-data emerged, it would be versioned at least 0.7.)
  * Slightly simplified the binary package interdependencies per
    Giacomo Catenazzi's advice.
  * To avoid abusing the present "urgency=high" upload, deferred
    further, non-urgent changes.

 -- Thaddeus H. Black <t@b-tk.org>  Mon, 20 Sep 2004 22:30:00 +0000

debram (0.5.0) unstable; urgency=low

  * Undertook not to change the format of `debram.txt' in 0.5.x or
    0.6.x, thus enabling users (per Giacomo Catenazzi's suggestion)
    later to install new `debram-data' packages or even just to load new
    `debram.txt' files without upgrading the `debram' package.  For this
    reason, incremented the minor version number to 0.5.
  * Planned to number the upcoming complete sarge ramification 0.6, to
    distinguish it from the present 0.5 which lacks complete sarge
    coverage.
  * Because the debram binary package no longer depends on a specific
    version of debram-data, gave debram its own copies of the copyright
    and changelog.gz files.  (Refer to Policy sects 12.5 and 12.7.)
  * Restricted the package license to GPL version 2, rather than GPL
    version 2 or later, thus withdrawing from the FSF its unique
    privilege to extend the license.
  * Implemented debram(1)'s -t option.
  * Added to the man page instructions on finding and installing the
    complete sarge ramification data, when they become available.
  * Extended the man page's Quick Start section.  Also, had the man page
    refer contributors to debtags-devel@lists.alioth.debian.org rather
    than to Thaddeus.  Edited and updated the page in a few other minor
    ways.
  * Merged into debian/rules Giacomo Catenazzi's patch to clean stray
    build stamps.
  * Added a HISTORY file per Enrico Zini's suggestion.
  * With Nick Lewycky's help, made the scripts `helper/new-debram-body'
    and `helper/sort-maint' fully relocatable.
  * Updated `maint.txt'.

 -- Thaddeus H. Black <t@b-tk.org>  Mon,  2 Aug 2004 00:00:00 +0000

debram (0.4.2) unstable; urgency=low

  * Observed here that this issue is principally a minor bugfix issue,
    and that more substantive modifications are deliberately held back
    against the apparent imminence of Debian sarge's release.  (Felt
    that a risk of introducing new bugs along with new features seemed a
    poor gamble at the moment.)
  * Disambiguated ram 8657's title from "Other Mail" (which was also
    ram 1657's title) to "Other Mail Transport".
  * Unswapped debram(1)'s seldom-used --data-file and --data-file-gz
    command-line options.


## debram 0.6.4

=== Makefile ===
--- 
+++ 
@@ -50,6 +50,8 @@
 argp_h    = $(def_h)             argp.h
 sel_h     = $(def_h)             sel.h
 color_h   = $(def_h) $(argp_h)   color.h
+utf8_h    = $(def_h) $(argp_h)   \
+                     $(color_h)  utf8.h
 ldf_h     = $(def_h)             ldf.h
 datum_h   = $(def_h)             datum.h
 xref_h    = $(def_h)             xref.h
@@ -64,6 +66,7 @@
             argp.o   \
             sel.o    \
             color.o  \
+            utf8.o   \
             ldf.o    \
             datum.o  \
             xref.o   \
@@ -82,6 +85,7 @@
 argp.o    : $(argp_h)   $(alloc_h)
 sel.o     : $(sel_h)    $(alloc_h)
 color.o   : $(color_h)  $(argp_h)
+utf8.o    : $(utf8_h)   $(alloc_h)
 ldf.o     : $(ldf_h)    $(argp_h)
 datum.o   : $(datum_h)  $(conv_h)   \
                         $(argp_h)   \
@@ -92,15 +96,18 @@
                         $(alloc_h)
 plan.o    : $(plan_h)   $(argp_h)   \
                         $(color_h)  \
+                        $(utf8_h)   \
                         $(xref_h)
 prdeb.o   : $(prdeb_h)  $(strx_h)   \
                         $(argp_h)   \
                         $(sel_h)    \
                         $(color_h)  \
+                        $(utf8_h)   \
                         $(datum_h)
 prram.o   : $(prram_h)  $(conv_h)   \
                         $(argp_h)   \
                         $(color_h)  \
+                        $(utf8_h)   \
                         $(datum_h)  \
                         $(prdeb_h)
 find.o    : $(find_h)   $(strx_h)   \
@@ -110,6 +117,7 @@
                         $(prdeb_h)
 main.o    : $(main_h)   $(argp_h)   \
                         $(sel_h)    \
+                        $(utf8_h)   \
                         $(xref_h)   \
                         $(plan_h)   \
                         $(prram_h)  \

=== debian/changelog ===
debram (0.6.4) unstable; urgency=medium

  * Prepared this upload pursuant to
    - http://lists.debian.org/debian-devel-announce/2005/04/msg00003.html
    - http://lists.debian.org/debian-release/2005/04/msg00029.html
    - http://lists.debian.org/debian-devel/2005/04/msg00161.html
    and the discussion threads descending therefrom.  Expected this
    issue to be the final issue before sarge's release.
  * Updated the ramification data to reflect sarge as of this date.
  * Excepting a handful of packages at their maintainers' request,
    purged data for packages not in sarge.
  * Updated maint.txt.

 -- Thaddeus H. Black <t@b-tk.org>  Sat,  2 Apr 2005 21:00:00 +0000

debram (0.6.3) unstable; urgency=low

  * Updated the ramification data to reflect sarge as of this date.
  * Updated maint.txt.
  * Added some minor new development helper scripts, including
    helper/update-ver and helper/update-date.

 -- Thaddeus H. Black <t@b-tk.org>  Wed,  9 Feb 2005 21:00:00 +0000

debram (0.6.2a) experimental; urgency=low

  * Added automatic locale support (with Maciej Dems).

 -- Thaddeus H. Black <t@b-tk.org>  Thu,  3 Feb 2005 00:00:00 +0000

debram (0.6.2) unstable; urgency=low

  * Updated the ramification data to reflect sarge as of this date.
  * Updated maint.txt.
  * Implemented debram(1)'s -u option to support utf-8 I/O.
    (Maciej Dems' good advice is acknowledged in this.)
  * Implemented debram(1)'s -. option.
  * Extended the manpage's list of library-data download sites.
  * Uncluttered debram(1)'s --help list somewhat by hiding a few
    rarely-used options (the manpage still documents them).

 -- Thaddeus H. Black <t@b-tk.org>  Mon, 24 Jan 2005 21:00:00 +0000

=== debian/control ===
Source: debram
Section: admin
Priority: optional
Maintainer: Thaddeus H. Black <t@b-tk.org>
Build-Depends: debhelper (>= 4.0.2), zlib1g-dev (>= 1:1.1.4-1.0woody0)
Standards-Version: 3.6.1

Package: debram
Section: admin
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, debram-data (>= ${Source-Version})
Suggests: debtags
Description: ramified catalog of available .debs
 Debian GNU/Linux provides thousands upon daunting thousands of software
 packages.  Sorting them into broad classes then dividing and redividing
 them into finer, more specific branches, the Debram ramifies Debian's
 packages in much the same manner as a university library ramifies its
 books.  If you know what you want your computer to do but do not yet
 know the package to do it, you can find the package here.

Package: debram-data
Section: admin
Priority: optional
Architecture: all
Recommends: debram (>= 0.5.1)
Conflicts: debram (<< 0.5.1)
Description: debram's architecture-independent data
 This data package installs the Debian Ramification's documentation and
 architecture-independent data.  It also provides the Command Selection
 Guide, ramifying eight hundred basic GNU/Linux commands.  See debram.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
# Modified by Thaddeus H. Black for debram.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEBRAM_OPTIM_LVL
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEBRAM_OPTIM_LVL := -O0
else
  DEBRAM_OPTIM_LVL := -O2
endif

build-arch: build-arch-stamp
build-arch-stamp:
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	touch build-indep-stamp

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp build-stamp
	-$(MAKE) clean
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_install debram usr/bin

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_install -i debram.txt usr/share/debram-data
	dh_installdocs -i
	dh_installchangelogs -i
	dh_compress -i usr/share/debram-data/debram.txt
	dh_link -i usr/share/debram-data/debram.txt.gz \
	  usr/share/doc/debram-data/debram.txt.gz
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installchangelogs -a
	for DOC in debram.txt $$( cat debian/debram-data.docs ) ; do \
	  dh_link -a usr/share/doc/debram-data/$${DOC}.gz \
	    usr/share/doc/debram/$${DOC}.gz ; \
	done
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_link -a usr/share/debram-data/debram.txt.gz \
	  usr/share/debram/debram.txt.gz
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## debram 0.6.5

=== debian/changelog ===
debram (0.6.5) unstable; urgency=low

  * Aggregated the changes in experimental versions 0.6.4a through d
    for official release to unstable (see those changelog entries).
  * Observed here that although further bugfixes are not impossible,
    neither are they expected; and that barring an urgent need,
    debram 0.6.5 is expected to the the last debram.
  * Offered admins the following counsel.
    - Sarge stable admins should install the binaries debram 0.6.4
      (distributed with sarge) and debram-data 0.6.5.
    - Sarge stable admins may build and install their own local
      debram 0.6.5 binaries.  This works fine; the source is already
      properly backported.  However, building one's own debram 0.6.5
      binary is unnecessary.  If unsure, follow the advice in the
      previous point.
    - Etch testing and sid unstable admins should install debram 0.6.5
      and debram-data 0.6.5.  They should also probably install debtags.
    - Although etch includes debram, most etch stable admins probably do
      not need it.  Instead, they can and should install debram's
      improved replacement debtags.
    - Etch+1 admins (and sid admins in the era following etch's release)
      do not need debram and, unless they have some unusual historical
      interest, should not install it.
  * Observed here that debram, useful for sarge users, is less useful
    post-sarge and is planned to be removed from Debian after etch's
    release.

 -- Thaddeus H. Black <t@b-tk.org>  Wed, 14 Sep 2005 00:00:00 +0000

debram (0.6.4d) experimental; urgency=low

  * Observed here that this experimental release is a candidate for
    0.6.5 release to sid three days to three weeks from today, if no
    further bugs emerge in the meantime.
  * Updated the FSF's postal address in debian/copyright.

 -- Thaddeus H. Black <t@b-tk.org>  Sat, 03 Sep 2005 00:00:00 +0000

debram (0.6.4c) experimental; urgency=low

  * Observed here that this experimental release is a candidate for
    0.6.5 release to sid three days to three weeks from today, if no
    further bugs emerge in the meantime.
  * Rebuilt debram.txt from the concatenated Packages files included
    with the official Debian 3.1r0a i386 CD set.  (The concatenated CD
    Packages files are substantially similar to the FTP Packages file.
    With respect to one or two packages of optional or extra Priority,
    however, the CDs and FTP seem to disagree on the exact package
    Priority.  Why?  Don't know.  Haven't investigated.  The difference
    admittedly does not amount to much.  Anyway, this debram build
    follows the CDs.)
  * Slightly modified maint.txt and helper/new-debram-body to handle
    correctly the concatenated CD Packages file.

 -- Thaddeus H. Black <t@b-tk.org>  Wed, 31 Aug 2005 00:00:00 +0000

debram (0.6.4b) experimental; urgency=low

  * Taking advantage of the helpful fact that sarge was now stable,
    reviewed the ramification top to bottom, correcting two or three
    hundred misramifications.  Observed that this was meant to be the
    last such general review.
  * Subdivided the 1740 and 9150 rams.
  * Added a few new cross-references between rams.
  * Added a new BUILDING text file, setting forth some notes relevant to
    users who want to build their own debram packages.
  * Added a new helper/RelSteps text file, outlining the steps the
    author typically takes in preparing a new debram release.
  * Added a minor iconv(3)-like capability to helper/new-debram-body.
  * Slightly corrected maint.txt.

 -- Thaddeus H. Black <t@b-tk.org>  Thu,  4 Aug 2005 00:00:00 +0000

debram (0.6.4a) experimental; urgency=low

  * Observed here that this is the first issue after sarge's release.
    Noted that the debram-data package issued here is fully compatible
    with sarge's debram (0.6.4) package, and that it is expected (and
    supported and recommended) that many sarge debram users will upgrade
    debram-data but not debram.
  * Observed here that the significance of this experimental issue and
    of the forthcoming 0.6.5 issue is that, unlike the 0.6.4 issue
    actually shipped with sarge, these later issues fully cover sarge.
    (The final sarge package list became available only just before
    sarge's release, by which time of course it was too late to update
    debram-data in sarge.  This was expected and planned.  Thus this
    issue, and the forthcoming 0.6.5.)
  * Updated the ramification data to cover all binary packages in sarge
    stable main i386.
  * Added a few new cross-references between rams.  Clarified the title
    of ram 8141.  Corrected a handful of package misramifications.
  * Edited the manpage significantly, reflecting the circumstances
    prevailing after sarge's stable release.  Among other changes,
    - deleted the "Updating the Library Data" section;
    - revised the "Bugs" section; and
    - added a notice that the -c option does not work well on terminals
      with white backgrounds.
  * Extended the Document History appropriately at debram.txt's foot.
  * Deleted one now unneeded helper script.  Slightly improved one or
    two of the others.
  * To avoid confusion for sarge users upgrading debram-data,
    refrained from updating the maintainer's e-mail address here
    to <thb@debian.org> (the maintainer is an official Debian Developer
    as of this issue).
  * Updated maint.txt to include all sarge package maintainers.
  * Observed here that the source is fully buildable on a sarge stable
    system, without any backporting modification.  Undertook to maintain
    such clean backportability for all 0.6.x issues.

 -- Thaddeus H. Black <t@b-tk.org>  Sat, 18 Jun 2005 00:00:00 +0000

## debram 1.0.2

=== debian/changelog ===
debram (1.0.2) unstable; urgency=medium

  * Updated the ramification data to reflect etch as of this date.
  * Updated maint.txt.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 25 Nov 2006 22:00:00 +0000

debram (1.0.1) unstable; urgency=medium

  * Updated the ramification data to reflect etch as of this date.
  * Empirically observed that the daily refresh of Debian's FTP archive
    seemed to run between 18:00 and 22:00 GMT (UTC); that is, that
    packages uploaded by 18:00 came early enough for the refresh,
    whereas Packages, Sources and Contents files had been built at least
    for the i386 and amd64 archs by 22:00 (although these do not
    actually appear on the Push-Primary mirrors until several hours
    later).  Delayed debram's daily changelog timestamp to 22:00 GMT for
    this reason.  (One could ask A.J. Towns for more precise hours, but
    really, the matter does not seem important enough to bother him
    about.)
  * Planned tentatively to track the amd64 Packages file, in addition to
    the i386, for etch+1, but noted that etch debram does not track
    packages unavailable in i386.
  * Corrected the spelling of [9358 System Administration under Gnome].
  * Updated maint.txt.
  * Referred to the debram (1.0.0) changelog to explain the upload's
    medium urgency.
  * Noted that this is probably the last unstable upload toward etch,
    but that by Debian Release Manager's permission, one extraordinary
    upload toward etch remains planned during the three weeks following
    Debian's general freeze.  (See the 1.0.0 changelog.)

 -- Thaddeus H. Black <thb@debian.org>  Fri, 06 Oct 2006 22:00:00 +0000

debram (1.0.0) unstable; urgency=medium

  * As proposed in the last changelog, advanced at last to
    version 1.0.0.
  * Also as proposed in the last changelog, advanced debram's ordinary
    upload urgency to the medium level, due to the essential
    perishability of debram's data.  (The maintainer knows of the
    Debian Project's internal development autobuilder sequencing
    algorithm, but notes that autobuilder priority is not what motivates
    this change.  What motivates it is that debram brings perishable
    metadata *on other packages,* which puts it in almost a unique
    position among Debian packages.  Little purpose is served by letting
    the metadata languish ten days in unstable.  Although debram is
    somewhat a bulky package, most of the bulk is data not code.
    Debram does not heavily load the autobuilders in any case.)
    Observed that significant updates to the debram(1) executable, if
    such occurred, would drop the urgency back to low.
  * Planned per Steve Langasek's permission
    [http://lists.debian.org/debian-release/2006/09/msg00224.html]
    to update debram during the three weeks following Debian's general
    freeze.  Observed that although this will not allow debram perfectly
    to track the stable release, it should help significantly, inasmuch
    as debram during those three weeks will have an almost stationary
    target to track.
  * Updated the ramification data to reflect etch as of this date.
  * Linked a few more ramification cross-references (See Also).
  * Rewrote "Updating the library data" in the manpage again.
  * Very slightly revised the commentary in docdata/cmdsel.txt.
  * Caused helper/new-debram-body, when it encounters an unknown
    maintainer name, to delay dying until it has gathered also all the
    other unknown maintainer names which could cause it to die.  Let it
    print all these names together at once to stderr, in both utf-8 and
    iso-8859-1 character encodings.
  * Updated maint.txt.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 18 Sep 2006 21:00:00 +0000

debram (0.7.0) unstable; urgency=low

  * Updated the ramification data to reflect etch as of this date.
  * Acknowledged Anoop Rajendra for ramifying some of the new packages.
  * Observed that this could be version 1.0.0, but cautiously numbered
    it 0.7.x for the moment.  Noted that future uploads before the etch
    release are likely to be marked urgency=medium, due to their
    perishable data.
  * Retreated from the post-1.0 version-numbering plan set forth in
    the 25 Feb 2006 changelog.  (It was a worthy idea, but premature.
    The proposal was too rigid for the demands of the present era of
    Debian development.)  Noted that big future reforms to the
    ramification plan would still increment at least the minor version
    number, but did not strictly define what might constitute a big
    reform.
  * For post-release stable ramification updates, undertook not to
    depart from the stable version number, but only to add a letter to
    it, as "1.2.3a".  (See "Updating the library data" in the manpage.
    Letters on non-stable numbers will continue to denote experimental
    versions, but in the future never on stable numbers.  For example,
    if Debian stable included debram 1.2.3, then debram 1.2.3a would be
    a stable ramification update.  An experimental debram would take the
    number 1.2.4a.)
  * Refined the ramification plan as follows.
    - Added the new [1273 Text Indexing and Searching].
    - Added the new [1458 General Mathematical Documentation].
    - Added the new [1474 Chemistry].
    - Retitled [1792 Debian Jr] to [1792 Debian Jr and Edu].
    - Added the new [2740 Vserver and Xen].
    - Retitled [2790 GNU Hurd] to [2790 GNU Hurd and kFreeBSD].
    - Split the old [3187 Other Revision Control] into three new
      branches: [3187 Other Centralized Revision Control];
      [3188 Arch/Tla/Bazaar]; and [3189 Other Decentralized Revision
      Control].
    - Retitled [3210 Fortran 77] to [3210 Fortran].
    - Added the new [3686 Perl 6] and [3688 GHC Haskell].
    - Added the new [4456 Proprietary Input Devices].
    - Retitled [4730 PCMCIA, APM and Other Mobile Devices]
      to [4730 Notebook Computers], and split it into several branches.


## debram 1.0.3

=== debian/changelog ===
debram (1.0.3) unstable; urgency=medium

  * Uploaded post-freeze to sid for etch
    per Steve Langasek's permission
    [http://lists.debian.org/debian-release/2006/09/msg00224.html].
  * Updated the ramification data to reflect etch as of this date.
  * Updated maint.txt.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 23 Dec 2006 22:00:00 +0000

## debram 1.0.3-0.1

=== debian/changelog ===
debram (1.0.3-0.1) unstable; urgency=low

  * NMU.
  * src/utf8.h: Include stddef.h.  Closes: #453160.  Patch by Kumar Appaiah
    <akumar@ee.iitm.ac.in>, thanks.

 -- Bart Martens <bartm@debian.org>  Sun, 09 Mar 2008 08:36:42 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: debram
 Section: admin
 Priority: optional
-Maintainer: Thaddeus H. Black <t@b-tk.org>
+Maintainer: Thaddeus H. Black <thb@debian.org>
 Build-Depends: debhelper (>= 4.0.2), zlib1g-dev (>= 1:1.1.4-1.0woody0)
-Standards-Version: 3.6.1
+Standards-Version: 3.7.2
 
 Package: debram
 Section: admin
@@ -28,5 +28,5 @@
 Description: debram's architecture-independent data
  This data package installs the Debian Ramification's documentation and
  architecture-independent data.  It also provides the Command Selection
- Guide, ramifying eight hundred basic GNU/Linux commands.  See debram.
+ Guide, ramifying several hundred basic GNU/Linux commands.  See debram.

## debram 1.0.3-0.2

=== Makefile ===
all .DEFAULT : ; cd src ; $(MAKE) $@
.PHONY       : all

=== src/Makefile ===

# Setting the DEBRAM_LOCAL environment variable causes this makefile
# correctly to build `debram' locally in the present directory, such
# that the `debram' executable seeks its library data file locally.
# To build `debram' locally, enter
#
#   $ DEBRAM_LOCAL=1 make
#
# Otherwise, this makefile builds `debram' for Debian packaging and
# distribution, such that the `debram' executable seeks its library data
# file in `/usr/lib/debram/':
#
#   $ make
#
# To prepare for an all-new build, enter one of
#
#   $ make clean
#   $ DEBRAM_LOCAL=1 make clean
#
# (The only difference between the two is that the latter cleans
# a few extra scratchpad files up, if they exist, as specified
# by $(clean_local) below.)
#
# To view the manpage locally, enter
#
#   $ man ./debram.1
#

prog     := debram

DEBRAM_OPTIM_LVL ?= -O2
ifdef DEBRAM_LOCAL
  ccdef       := -DDEBRAM_LOCAL
  warn        := -Wall
  clean_local := a.out out err
else
  optim       := $(DEBRAM_OPTIM_LVL) -g -fomit-frame-pointer
endif

CFLAGS   += $(warn) $(ccdef) $(optim)
LDFLAGS  += $(warn)

LDLIBS   += -lz

def_h     =                      def.h
gen_h     = $(def_h)             gen.h
alloc_h   =                      alloc.h
strx_h    = $(def_h)             strx.h
conv_h    = $(def_h)             conv.h
argp_h    = $(def_h)             argp.h
sel_h     = $(def_h)             sel.h
color_h   = $(def_h) $(argp_h)   color.h
utf8_h    = $(def_h) $(argp_h)   \
                     $(color_h)  utf8.h
ldf_h     = $(def_h)             ldf.h
datum_h   = $(def_h)             datum.h
xref_h    = $(def_h)             xref.h
plan_h    = $(def_h)             plan.h
prdeb_h   = $(def_h) $(datum_h)  prdeb.h
prram_h   = $(def_h) $(xref_h)   prram.h
find_h    = $(def_h)             find.h
main_h    = $(def_h)             main.h

obj      := strx.o   \
            conv.o   \
            argp.o   \
            sel.o    \
            color.o  \
            utf8.o   \
            ldf.o    \
            datum.o  \
            xref.o   \
            plan.o   \
            prdeb.o  \
            prram.o  \
            find.o   \
            main.o

all       : $(prog)
.PHONY: all

$(prog)   : $(obj)
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)

$(obj)    : $(gen_h)
strx.o    : $(strx_h)
conv.o    : $(conv_h)
argp.o    : $(argp_h)   $(alloc_h)
sel.o     : $(sel_h)    $(alloc_h)
color.o   : $(color_h)  $(argp_h)
utf8.o    : $(utf8_h)   $(alloc_h)
ldf.o     : $(ldf_h)    $(argp_h)
datum.o   : $(datum_h)  $(conv_h)   \
                        $(argp_h)   \
                        $(ldf_h)
xref.o    : $(xref_h)   $(strx_h)   \
                        $(argp_h)   \
                        $(datum_h)  \
                        $(alloc_h)
plan.o    : $(plan_h)   $(argp_h)   \
                        $(color_h)  \
                        $(utf8_h)   \
                        $(xref_h)
prdeb.o   : $(prdeb_h)  $(strx_h)   \
                        $(argp_h)   \
                        $(sel_h)    \
                        $(color_h)  \
                        $(utf8_h)   \
                        $(datum_h)
prram.o   : $(prram_h)  $(conv_h)   \
                        $(argp_h)   \
                        $(color_h)  \
                        $(utf8_h)   \
                        $(datum_h)  \
                        $(prdeb_h)
find.o    : $(find_h)   $(strx_h)   \
                        $(argp_h)   \
                        $(datum_h)  \
                        $(xref_h)   \
                        $(prdeb_h)
main.o    : $(main_h)   $(argp_h)   \
                        $(sel_h)    \
                        $(utf8_h)   \
                        $(xref_h)   \
                        $(plan_h)   \
                        $(prram_h)  \
                        $(find_h)

.PHONY    : clean
clean     :
	rm -f $(prog) $(obj) $(clean_local)

=== debian/changelog ===
debram (1.0.3-0.2) unstable; urgency=low

  * Non-maintainer Upload.
  * Use source:Version instead of Source-Version to fix binNMU installability
    (Closes: Bug#677881).

 -- Samuel Thibault <sthibault@debian.org>  Tue, 19 Jun 2012 15:01:41 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Section: admin
 Priority: optional
 Architecture: any
-Depends: ${shlibs:Depends}, debram-data (>= ${Source-Version})
+Depends: ${shlibs:Depends}, debram-data (>= ${source:Version})
 Suggests: debtags
 Description: ramified catalog of available .debs
  Debian GNU/Linux provides thousands upon daunting thousands of software

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,10 @@
 # Sample debian/rules that uses debhelper.
 # GNU copyright 1997 to 1999 by Joey Hess.
 # Modified by Thaddeus H. Black for debram.
+
+out      := debram
+out_data := $(out)-data
+docdata  := docdata
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -40,19 +44,19 @@
 	dh_testroot
 	dh_clean -k
 	dh_installdirs
-	dh_install debram usr/bin
+	dh_install src/$(out) usr/bin
 
 # Build architecture-independent files here.
 # Pass -i to all debhelper commands in this target to reduce clutter.
 binary-indep: build install
 	dh_testdir -i
 	dh_testroot -i
-	dh_install -i debram.txt usr/share/debram-data
+	dh_install -i $(docdata)/$(out).txt usr/share/$(out_data)
 	dh_installdocs -i
 	dh_installchangelogs -i
-	dh_compress -i usr/share/debram-data/debram.txt
-	dh_link -i usr/share/debram-data/debram.txt.gz \
-	  usr/share/doc/debram-data/debram.txt.gz
+	dh_compress -i usr/share/$(out_data)/$(out).txt
+	dh_link -i usr/share/$(out_data)/$(out).txt.gz \
+	  usr/share/doc/$(out_data)/$(out).txt.gz
 	dh_fixperms -i
 	dh_installdeb -i
 	dh_gencontrol -i
@@ -65,15 +69,20 @@
 	dh_testroot -a
 	dh_installdocs -a
 	dh_installchangelogs -a
-	for DOC in debram.txt $$( cat debian/debram-data.docs ) ; do \
-	  dh_link -a usr/share/doc/debram-data/$${DOC}.gz \
-	    usr/share/doc/debram/$${DOC}.gz ; \
+	for DOC in \
+	  $(out).txt \
+	  $$( sed -ne 's/^$(docdata)\///p' debian/$(out_data).docs ) \
+	; do \
+	  dh_link -a usr/share/doc/$(out_data)/$${DOC}.gz \
+	    usr/share/doc/$(out)/$${DOC}.gz ; \
 	done
+	dh_link -a usr/share/doc/$(out_data)/README \
+	  usr/share/doc/$(out)/README
 	dh_installman -a
 	dh_strip -a
 	dh_compress -a
-	dh_link -a usr/share/debram-data/debram.txt.gz \
-	  usr/share/debram/debram.txt.gz
+	dh_link -a usr/share/$(out_data)/$(out).txt.gz \
+	  usr/share/$(out)/$(out).txt.gz
 	dh_fixperms -a
 	dh_installdeb -a
 	dh_shlibdeps -a
